# -*- coding:Utf-8 -*-
# welcom_sound by DoC (09/12/2007)
# mattie 2.0 ou plus
#=========================#

import re,os,es,random
ws_info=es.AddonInfo()
ws_info.name='welcom_sound'
ws_info.version='1.0b'
ws_info.author='DoCky'
ws_info.url='http://mattie.info/forums/'
ws_info.description='play random sounds when a player reaches server'
ws_info.tags='français;music;sound;python'

#          EVENT
#-------------------------#

def load():
        global ws_next
        ws_next=-1
        es_map_start(es_map_start)

def es_map_start(event_var):
        if not WelcomSound.FileExist():es.log('[welcom_sound] fichier manquant')
        else:
                global ws_next
                global ws_join
                es.ForceServerCommand('es_mexec ../addons/eventscripts/welcom_sound/config.cfg')
                ws_list=FileAnalyse().SoundList()

                if not ws_list:es.log('[welcom_sound] liste des sons vide')
                else:
                        if int(WelcomSound.ws_rand):
                                ws_join=RandomSound(ws_list).GetSound()
                        elif ws_next==len(ws_list)-1:
                                ws_next=0
                                ws_join=ws_list[ws_next]
                        else:
                                ws_next+=1
                                ws_join=ws_list[ws_next]

def player_activate(event_var):es.playsound(event_var['userid'],ws_join,1)


#          CLASS
#-------------------------#

class WelcomSound:
        ws_vers=es.ServerVar(ws_info.name,ws_info.version,'version actuelle du script')
        ws_vers.set(ws_info.version)
        ws_vers.makepublic()

        ws_down=es.ServerVar('ws_down')
        ws_rand=es.ServerVar('ws_rand')

        @staticmethod
        def ScritpDir():return es.getAddonPath(ws_info.name).replace(os.sep,'/')

        @staticmethod
        def FileExist():
                if not os.path.isfile(WelcomSound.ScritpDir()+'/config.cfg')or not os.path.isfile(WelcomSound.ScritpDir()+'/sound.cfg'):return False
                else:return True

class FileAnalyse:
        def __init__(self):
                try:
                        ws_read=open(WelcomSound.ScritpDir()+'/sound.cfg','r')
                        self.read=ws_read.read().split('\n')
                        self.__analyse()
                        ws_read.close()
                except:es.log('[welcom_sound] lecture impossible du fichier sound.cfg')

        def __analyse(self):
                ws_line=0
                while ws_line<len(self.read):
                        self.read[ws_line]=self.__comment(self.read[ws_line])
                        self.read[ws_line]=self.__spantab(self.read[ws_line])
                        self.read[ws_line]=self.__returns(self.read[ws_line])
                        self.read[ws_line]=self.__accents(self.read[ws_line])
                        if not self.read[ws_line]:self.read.remove(self.read[ws_line])
                        else:
                                if int(WelcomSound.ws_down):self.__dlfiles(self.read[ws_line])
                                ws_line+=1

        def __comment(self,comment):return re.sub(('//.*'),'',comment)

        def __spantab(self,spantab):return re.sub(('^(( |\t)+)|(( |\t)+)$'),'',spantab)

        def __returns(self,returns):return returns.replace('\r','')

        def __accents(self,accents):return accents.replace('"','')

        def __dlfiles(self,dlfiles):return es.stringtable('downloadables','sound/'+dlfiles)

        def SoundList(self):return self.read[:]

class RandomSound:
        def __init__(self,sound):self.play=sound[random.randint(0,len(sound)-1)]

        def GetSound(self):return self.play
